#pragma once

#if defined(_WIN32_WCE)
#include "atlcectrls.h"
#endif

class CHexCodePanel :
#if !defined(_WIN32_WCE)
	public CWindowImpl<CHexCodePanel, CEdit> // WTL::CRichEditCtrl>
#else
	public CWindowImpl<CHexCodePanel, CEdit> // WTL::CRichInkCtrl>
#endif
{
public:
	CHexCodePanel(void);
	~CHexCodePanel(void);

	bool mCodeDisplay;
	int mMenuID;
	HWND mParentWnd;
	CPoint mMenuPt;

	// Display a popup menu at point (x,y)
	void ContextMenu(int x, int y);

#if 0
	BEGIN_MSG_MAP_EX(CHexCodePanel)
		MSG_WM_ERASEBKGND(OnEraseBkgnd)
		MSG_WM_LBUTTONDOWN(OnLButtonDown)
		MSG_WM_LBUTTONUP(OnLButtonUp)
		MSG_WM_LBUTTONDBLCLK(OnLButtonDblClk)
		MSG_WM_MOUSEMOVE(OnMouseMove)
		MSG_WM_CONTEXTMENU(OnContextMenu)
	END_MSG_MAP()

	BOOL OnEraseBkgnd(HDC hDC);
	void OnLButtonDown(UINT nFlags, CPoint point);
	void OnLButtonUp(UINT nFlags, CPoint point);
	void OnLButtonDblClk( UINT, CPoint );
	void OnMouseMove(UINT nFlags, CPoint point);
	void OnContextMenu(HWND hWnd, CPoint point);
#endif

	BEGIN_MSG_MAP(CHexCodePanel)
		MESSAGE_HANDLER(WM_CONTEXTMENU, OnContextMenu)
		MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBkgnd)
		MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
		MESSAGE_HANDLER(WM_LBUTTONDBLCLK, OnLButtonDblClk)
		MESSAGE_HANDLER(WM_LBUTTONUP, OnLButtonUp)
		COMMAND_ID_HANDLER(ID_VIEW_ASM, OnViewAsm)
		COMMAND_ID_HANDLER(ID_VIEW_HEX, OnViewHex)
	END_MSG_MAP()

	LRESULT OnContextMenu(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnEraseBkgnd(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnLButtonDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnLButtonDblClk(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnLButtonUp(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnViewAsm(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnViewHex(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
};
