// Specialization of PIC programming for the PIC18F 2XX0/2XX5/4XX0/4XX5 chips.
#pragma once
#include "pic18fxxxprogram.h"

class PIC18FXX31Program :
	public PIC18FXXXProgram
{
public:
	// Get the singleton instance of this class of PIC programming code
	static const PICProgram *GetDriver();

	// int Erase(CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;

private:
	static PIC18FXX31Program m_Driver;

	//int ReadCode(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;
	int WriteCode(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;
	//int WriteData(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;

	//int EraseCode(CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF) const;
	//int EraseCmd(CIOPort *port, PICHexFile *hexFile, uint cmd) const;
};
