// Specialization of PIC programming for the PIC18F 2XX0/2XX5/4XX0/4XX5 chips.

#pragma once
#include "pic18fxxxprogram.h"

class PIC18FXX5XProgram :
	public PIC18FXXXProgram
{
public:
	// Get the singleton instance of this class of PIC programming code
	static const PICProgram *GetDriver();

	// int Program(CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;
	// int PartialProgram(CIOPort *port, PICHexFile *hexFile, bool codeFlag = false, bool dataFlag = false, bool configFlag = false, CProgrammerProgressIF *statusIF = NULL) const;
	// int EraseCmd(CIOPort *port, PICHexFile *hexFile, uint cmd) const;
	int Erase(CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;
	int PartialErase(CIOPort *port, PICHexFile *hexFile, bool bootFlag = false, bool codeFlag = false, bool dataFlag = false, bool configFlag = false, CProgrammerProgressIF *statusIF = NULL) const;

private:
	static PIC18FXX5XProgram m_Driver;

	// int ReadData(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;

	// int WriteCode(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;
	// int WriteData(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;
};

