// VBProgView.h : interface of the CEvaView class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include "configPageDlg.h"
#include "hexPageDlg.h"

class CEvaView : public CDialogImpl<CEvaView>
{
public:
	enum { IDD = IDD_EVA_FORM };

	void addTabPages(void);
	CTabCtrl m_tabCtrl;
	ChexPageDlg *m_hexPage1; 
	ChexPageDlg *m_hexPage2; 
	CconfigPageDlg *m_configPage; 

	bool m_inHighRes;
	int m_charHeight;
	int m_fontIndex;
	CFont *m_highResFonts;
	CFont *m_lowResFonts;
	int m_fontPointSize;
	void uncheckAllFontSizes();
	void checkMenuItem(int itemID);

	void createFonts();

	BOOL PreTranslateMessage(MSG* pMsg);

	BEGIN_MSG_MAP(CEvaView)
		NOTIFY_HANDLER(IDC_TAB_VIEW, TCN_SELCHANGE, OnTcnSelchangeTabView)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
	END_MSG_MAP()

// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)
LRESULT OnTcnSelchangeTabView(int /*idCtrl*/, LPNMHDR pNMHDR, BOOL& /*bHandled*/);
LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
LRESULT OnSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
};
