#include "StdAfx.h"
#include "resource.h"
#include <winuser.h>

#include "HexWordEdit.h"
#include ".\hexwordedit.h"

CHexWordEdit::CHexWordEdit(void)
{
}

CHexWordEdit::~CHexWordEdit(void)
{
}

int CHexWordEdit::HexValue()
{
	int val = -1;
	TCHAR strBuf[17];
	GetWindowText(strBuf, 16);
	_stscanf(strBuf, _T("%x"), &val);

	return val;
}


LRESULT CHexWordEdit::OnKeyDown(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& bHandled)
{
	// Ignore anything but 0-9, a-f, A-F.
	int keyCode = (int)wParam;
	if (isdigit(keyCode) || ((keyCode >= 'a') && (keyCode <= 'f')) ||
		((keyCode >= 'A') && (keyCode <= 'F')))
		nonHexFlag = false;
	else
	{
		switch (wParam)
		{
		case VK_END:
		case VK_HOME:
		case VK_LEFT:
		case VK_RIGHT:
		case VK_INSERT:
		case VK_DELETE:
		case VK_BACK:
			nonHexFlag = false;
			break;
		default:
			nonHexFlag = true;
			break;
		}
	}

	bHandled = FALSE;
	return 0;
}

LRESULT CHexWordEdit::OnChar(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
{
	if (nonHexFlag)
	{
		bHandled = TRUE;
		return 0;
	}
	else
	{
		bHandled = FALSE;
		return 1;
	}
}
