#include "StdAfx.h"
#include "RegistersDlg.h"

CRegistersDlg::CRegistersDlg(void)
{
}

CRegistersDlg::~CRegistersDlg(void)
{
}

LRESULT CRegistersDlg::OnOk(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	EndDialog(IDOK);

	return 0;
}

void CRegistersDlg::SetItemValue(int index, unsigned char value)
{
	TCHAR buf[32];
	_stprintf(buf, _T("0x%02X"), value);
	SetDlgItemText(index, buf);
}

void CRegistersDlg::SetValues(unsigned char *values)
{
	memcpy(mValues, values, sizeof(mValues));
}

LRESULT CRegistersDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	SetItemValue(IDC_INTCON, mValues[ 0]);
	SetItemValue(IDC_INTCON2, mValues[ 1]);
	SetItemValue(IDC_INTCON3, mValues[ 2]);
	SetItemValue(IDC_T0CON, mValues[ 3]);
	SetItemValue(IDC_OSCCON, mValues[ 4]);
	SetItemValue(IDC_HLVDCON, mValues[ 5]);
	SetItemValue(IDC_WDTCON, mValues[ 6]);
	SetItemValue(IDC_RCON, mValues[ 7]);
	SetItemValue(IDC_T1CON, mValues[ 8]);
	SetItemValue(IDC_PR2, mValues[ 9]);
	SetItemValue(IDC_T2CON, mValues[10]);
	SetItemValue(IDC_ADRESH, mValues[11]);
	SetItemValue(IDC_ADRESL, mValues[12]);
	SetItemValue(IDC_ADCON0, mValues[13]);
	SetItemValue(IDC_ADCON1, mValues[14]);
	SetItemValue(IDC_ADCON2, mValues[15]);
	SetItemValue(IDC_CCPR1H, mValues[16]);
	SetItemValue(IDC_CCPR1L, mValues[17]);
	SetItemValue(IDC_CCP1CON, mValues[18]);
	SetItemValue(IDC_CCPR2H, mValues[19]);
	SetItemValue(IDC_CCPR2L, mValues[20]);
	SetItemValue(IDC_CCP2CON, mValues[21]);
	SetItemValue(IDC_BAUDCON, mValues[22]);
	SetItemValue(IDC_CVRCON, mValues[23]);
	SetItemValue(IDC_CMCON, mValues[24]);
	SetItemValue(IDC_T3CON, mValues[25]);
	SetItemValue(IDC_SPBRGH, mValues[26]);
	SetItemValue(IDC_SPBRG, mValues[27]);
	SetItemValue(IDC_TXSTA, mValues[28]);
	SetItemValue(IDC_RCSTA, mValues[29]);
	SetItemValue(IDC_IPR2, mValues[30]);
	SetItemValue(IDC_PIR2, mValues[31]);
	SetItemValue(IDC_PIE2, mValues[32]);
	SetItemValue(IDC_IPR1, mValues[33]);
	SetItemValue(IDC_PIR1, mValues[34]);
	SetItemValue(IDC_PIE2, mValues[35]);
	SetItemValue(IDC_OSCTUNE, mValues[36]);
	SetItemValue(IDC_TRISE, mValues[37]);
	SetItemValue(IDC_TRISD, mValues[38]);
	SetItemValue(IDC_TRISC, mValues[39]);
	SetItemValue(IDC_TRISB, mValues[40]);
	SetItemValue(IDC_TRISA, mValues[41]);
	SetItemValue(IDC_PORTE, mValues[42]);
	SetItemValue(IDC_PORTD, mValues[43]);
	SetItemValue(IDC_PORTC, mValues[44]);
	SetItemValue(IDC_PORTB, mValues[45]);
	SetItemValue(IDC_PORTA, mValues[46]);

	SetItemValue(IDC_UEP3, mValues[47]);
	SetItemValue(IDC_UEP2, mValues[48]);
	SetItemValue(IDC_UEP1, mValues[49]);
	SetItemValue(IDC_UEP0, mValues[50]);
	SetItemValue(IDC_UCFG, mValues[51]);
	SetItemValue(IDC_UADDR, mValues[52]);
	SetItemValue(IDC_UCON, mValues[53]);
	SetItemValue(IDC_USTAT, mValues[54]);
	SetItemValue(IDC_UEIE, mValues[55]);
	SetItemValue(IDC_UEIR, mValues[56]);
	SetItemValue(IDC_UIE, mValues[57]);
	SetItemValue(IDC_UIR, mValues[58]);
	SetItemValue(IDC_UFRMH, mValues[59]);
	SetItemValue(IDC_UFRML, mValues[60]);

	SetItemValue(IDC_BD0STAT, mValues[61]);
	SetItemValue(IDC_BD0CNT, mValues[62]);
	SetItemValue(IDC_BD0ADRL, mValues[63]);
	SetItemValue(IDC_BD0ADRH, mValues[64]);
	SetItemValue(IDC_BD1STAT, mValues[65]);
	SetItemValue(IDC_BD1CNT, mValues[66]);
	SetItemValue(IDC_BD1ADRL, mValues[67]);
	SetItemValue(IDC_BD1ADRH, mValues[68]);
	return TRUE;
}
