// configPageDlg.h : Declaration of the CconfigPageDlg

#pragma once

#include "resource.h"       // main symbols

// CconfigPageDlg

class CconfigPageDlg : 
	public CDialogImpl<CconfigPageDlg>
{
public:
	enum { IDD = IDD_CONFIGPAGEDLG };

	CComboBox m_DeviceList;
	CComboBox m_PortList;
	CButton m_testVpp;
	CButton m_testVdd;
	CButton m_testClock;
	CButton m_testData;
	CButton m_openButton;

BEGIN_MSG_MAP(CconfigPageDlg)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDC_COMBO_DEVICE_LIST, CBN_SELCHANGE, OnCbnSelchangeComboDeviceList)
	COMMAND_HANDLER(IDC_BUTTON_TEST_OPEN, BN_CLICKED, OnBnClickedButtonTestOpen)
END_MSG_MAP()

// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnCbnSelchangeComboDeviceList(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedButtonTestOpen(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
};


