#pragma once

#include "Serial/Serial0.h"
#include "Serial/USBDevice.h"

class CIOPort
{
public:
	CIOPort(void);
public:
	~CIOPort(void);
public:
	bool Open(LPCTSTR portName, int baudRate);
	int Close();
	void Purge();
	void Flush();
	bool IsOpen();

	CSerial m_Serial;
	USBDevice m_USB;
};
